/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	セットアップ抽象クラス
//			変更履歴
//				2004.01.08	新規作成	五木田 泰史
//

package jp.co.ntt.lms.lo;

import java.util.Hashtable;

/**
 * セットアップ抽象クラス
 *
 * <PRE>
 *   Loのセットアップ(登録・更新・削除)をする。
 *   LoServerクラスが所有する。
 *   下位に各LoのLoセットアップクラスを持つ。
 * </PRE>
 *
 */
public abstract class Setup implements LoPropertyDef
{
	/**
	 * セットアップ処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException Lo固有の例外エラー
	 */
	public void setUp(Hashtable htbParam)
			throws LOException
	{
		try
		{
			String strEditFlag = "";
			strEditFlag        = (String)htbParam.get(SETUP_STATUS);
			if(strEditFlag == null || strEditFlag.equals(""))
			{
				throw new LOException("WbtSetupError1 : セットアップ状態が[" + strEditFlag + "]です。");
			}
			else if(strEditFlag.equals(SETUP_INSERT))
			{
				// 登録処理
				setupInsert(htbParam);
			}
			else if(strEditFlag.equals(SETUP_UPDATE))
			{
				// 更新処理
				setupUpdate(htbParam);
			}
			else if(strEditFlag.equals(SETUP_DELETE))
			{
				// 削除処理
				setupDelete(htbParam);
			}
			else if(strEditFlag.equals(SETUP_ADDUSER))
			{
				// ユーザ登録処理
				setupAddUser(htbParam);
			}
			else if(strEditFlag.equals(SETUP_DELUSER))
			{
				// ユーザ削除処理
				setupDelUser(htbParam);
			}
			else if(strEditFlag.equals(SETUP_COPY))
			{
				// LOコピー処理
				setupCopy(htbParam);
			}
			else
			{
				throw new LOException("WbtSetupError2 : セットアップ状態が[" + strEditFlag + "]です。");
			}
		}
		catch(LOException le)
		{
			throw le;
		}
	}

	////////////////////////////////////////////////////////////////////////////
	// 抽象メソッド
	////////////////////////////////////////////////////////////////////////////
	/**
	 * セットアップ登録処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected abstract void setupInsert(Hashtable htbParam) throws LOException;

	/**
	 * セットアップ更新処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected abstract void setupUpdate(Hashtable htbParam) throws LOException;

	/**
	 * セットアップ削除処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected abstract void setupDelete(Hashtable htbParam) throws LOException;

	/**
	 * セットアップユーザ登録処理
	 *
	 * @param htbParam パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected abstract void setupAddUser(Hashtable htbParam) throws LOException;

	/**
	 * セットアップユーザ削除処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected abstract void setupDelUser(Hashtable htbParam) throws LOException;

	/**
	 * セットアップコピー処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected abstract void setupCopy(Hashtable htbParam) throws LOException;

}

